uses crt, dos;

const MAXbs=15;

var rad : integer;
    CITAC : integer;


type

puzel = ^uzel;


uzel = record
  data : array[0..MAXbs] of integer;
  ukaz : array[0..MAXbs] of puzel;
  ukazzp : puzel;
  pocet : integer;
end;

bstrom = object
  koren : puzel;
  procedure novy(rrad : integer);
  function pridej(klic : integer) : boolean;
  function uber(klic : integer) : boolean;
  function najdi(klic : integer) : boolean;

  procedure vypis;
end;

type pole = array[0..30] of integer;
var ppole : array[0..10] of pole;
    hloubka : integer;
    nejh : integer;
    polei : array[0..10] of integer;

procedure x(a : puzel);
var i : integer;
begin

  for i:= 0 to a^.pocet-1 do begin
    ppole[hloubka][polei[hloubka]]:= a^.data[i];
    polei[hloubka]:= polei[hloubka] + 1;
  end;
  ppole[hloubka][polei[hloubka]]:= -1;
  polei[hloubka]:= polei[hloubka] + 1;


  if a^.ukaz[0] <> NIL then
  begin
    for i:= 0 to a^.pocet do begin
      hloubka:= hloubka + 1;
      if a^.ukaz[i] <> NIL then x(a^.ukaz[i]);
    end;
  end;

  if nejh < hloubka then nejh:= hloubka;
  hloubka:= hloubka - 1;
end;

procedure bstrom.vypis;
var i, j: integer;
    a: puzel;
begin

  hloubka:= 0;
  nejh:= 0;
  {pole smaz}
  for i:= 0 to 30 do begin
    for j:= 0 to 10 do begin
      ppole[j][i]:= 0;
      polei[j]:= 0;
    end;
  end;

  x(koren);

  for j:= 0 to nejh do begin
    for i:= 0 to polei[j]-1 do begin
      if (ppole[j][i] = -1) then write('|')
      else write(ppole[j][i], ' ');
    end;
    writeln;
  end;



{  clrscr;}
(*  a:= koren.ukaz[0]^.ukaz[1];
  a:= koren.ukaz[0];
  a:= koren.ukaz[0]^.ukazzp;
  a:= @koren;   {adresa pameti, kde je ulozen koren}
  a:= koren.ukaz[2]^.ukazzp;
  a:= koren.ukaz[0]^.ukaz[1];
  for i:= 0 to a^.pocet-1 do begin
    write(a^.data[i],' ');
  end;
*)
end;

function rozdel(var a : puzel) : boolean;       {a ukazuje na auzel}
var hotovo : boolean;
    l, p : puzel;
    i, pomoc, j : integer;
    pridej, ppomoc : puzel;
    klic : integer;
begin
  hotovo:= true;
  if a^.ukazzp = NIL then begin         {pripad korenu}
    new(l);
    new(p);

    for i:= 0 to rad-1 do begin
      l^.data[i]:= a^.data[i];
      l^.ukaz[i]:= a^.ukaz[i];
      inc(CITAC);
    end;
    l^.ukaz[i+1]:= a^.ukaz[i+1];
    l^.ukazzp:=a;
    l^.pocet:=rad;
    for i:= 0 to l^.pocet do begin              {zmeni ukazatele na predka u potomku korenu}
      l^.ukaz[i]^.ukazzp:= l;
      inc(CITAC);
    end;
    for i:= l^.pocet to 2*rad do begin
      l^.ukaz[i+1]:= NIL;
      l^.data[i]:= 0;
    end;

    for i:= rad+1 to 2*rad do begin
      p^.data[i-rad-1]:= a^.data[i];
      p^.ukaz[i-rad-1]:= a^.ukaz[i];
      inc(CITAC);
    end;
    p^.ukaz[i-rad]:= a^.ukaz[i+1];
    p^.ukazzp:=a;
    p^.pocet:=rad;
    for i:= 0 to p^.pocet do begin
      p^.ukaz[i]^.ukazzp:= p;
      inc(CITAC);
    end;
    for i:= p^.pocet to 2*rad do begin
      p^.ukaz[i+1]:= NIL;
      p^.data[i]:= 0;
    end;

    a^.data[0]:= a^.data[rad];
    a^.ukaz[0]:= l;
    a^.ukaz[1]:= p;
    a^.pocet:= 1;
    for i:= a^.pocet to 2*rad do begin
      a^.ukaz[i+1]:= NIL;
      a^.data[i]:= 0;
    end;

  end
  else begin                                    {kdyz to neni koren}
    new(p);                                     {novy pravy podstrom}
    for i:= 0 to rad-1 do begin
      p^.data[i]:= a^.data[rad+1+i];
      p^.ukaz[i]:= a^.ukaz[rad+1+i];
      inc(CITAC);
    end;
    p^.ukaz[i+1]:= a^.ukaz[rad+2+i];            {kopirejeme posledni ukazatel}
    p^.ukazzp:=a^.ukazzp;
    p^.pocet:=rad;
    for i:= p^.pocet to 2*rad do begin
      p^.ukaz[i+1]:= NIL;
      p^.data[i]:= 0;
    end;

    if p^.ukaz[0] <> NIL then begin               {v pripade listu uz neexistujou potomci}
      for i:= 0 to p^.pocet do begin              {nastavi se ukazatel na predka pro novy pravy podstrom}
        p^.ukaz[i]^.ukazzp:= p;
        inc(CITAC);
      end;
    end;

    a^.pocet:=rad;
    klic:= a^.data[rad];                        {klic je prostredni prvek}
    pridej:= p;                                 {pridej je novy pravy podstrom}
    for i:= a^.pocet to 2*rad do begin
      a^.ukaz[i+1]:= NIL;
      a^.data[i]:= 0;
    end;

    a:= a^.ukazzp;                              {jdi do predka}


    j:= a^.pocet;
    for i:= 0 to a^.pocet-1 do begin                    {hleda se kam vlozit klic}
       inc(CITAC);
       if a^.data[i] > klic then begin
         j:= i;
         break;
       end;
    end;
    a^.pocet:= a^.pocet + 1;

    for i:=j to a^.pocet-1 do begin               {posunou se prvky a ukazatele o jeden}
      pomoc:= a^.data[i];
      ppomoc:= a^.ukaz[i+1];
      a^.data[i]:= klic;
      a^.ukaz[i+1]:= pridej;
      klic:= pomoc;
      pridej:= ppomoc;
      inc(CITAC);
    end;

    if a^.pocet > rad*2 then hotovo:= false;
  end;

  rozdel:= hotovo;
end;

procedure bstrom.novy(rrad : integer);
var i : integer;
begin
  rad:= rrad;

  new(koren);

  for i:= 0 to 2*rad do begin
    koren^.data[i]:= 0;
    koren^.ukaz[i]:= NIL;
  end;
  koren^.ukaz[i+1]:= NIL;
  koren^.pocet:= 0;
  koren^.ukazzp:= NIL;
end;

function bstrom.pridej(klic : integer) : boolean;
var i, j, pomoc : integer;
    a : puzel;
    hotovo, chyba, skok : boolean;
begin
  chyba:= false;
  a:= koren;

  while a^.ukaz[0] <> NIL do begin                  {hleda se list}
    inc(CITAC);
    skok:= false;
    for i:= 0 to a^.pocet-1 do begin
      inc(CITAC);
       if klic < a^.data[i] then begin
         skok:= true;
         break;
       end;
       if a^.data[i] = klic then chyba:= true;
    end;
    if skok then a:= a^.ukaz[i]
    else a:= a^.ukaz[a^.pocet];
  end;

  j:= a^.pocet;
  for i:= 0 to a^.pocet - 1  do begin                    {najde kam ulozit klic}
     inc(CITAC);
     if a^.data[i] > klic then begin
       j:= i;
       break;
     end;
     if a^.data[i] = klic then chyba:= true;
  end;

  if not chyba then begin
  a^.pocet:= a^.pocet + 1;

  for i:=j to a^.pocet-1 do begin                     {posune data o jeden}
    inc(CITAC);
    pomoc:= a^.data[i];
    a^.data[i]:= klic;
    klic:= pomoc;
  end;
  a^.ukaz[a^.pocet-1]:= NIL;

  if (a^.pocet > 2*rad) then begin
    hotovo:= false;
    while hotovo <> true do begin
      inc(CITAC);
      hotovo:= rozdel(a);
    end;
  end;

  end;
  pridej:= not chyba;
end;

function pujcsluc(var a : puzel; var c : integer) : boolean;
var i, puc : integer;
    b, l, p : puzel;
    povedlo, hotovo : boolean;
begin
    hotovo:= true;
    for i:= c+1 to a^.pocet-1 do begin          {mazani prvku c}
      inc(CITAC);
      a^.data[i-1]:= a^.data[i];
      a^.ukaz[i-1]:= a^.ukaz[i];
    end;
    a^.ukaz[i]:= a^.ukaz[i+1];
    a^.pocet:= a^.pocet-1;
    for i:= a^.pocet to 2*rad do begin
      a^.ukaz[i+1]:= NIL;
      a^.data[i]:= 0;
    end;

    if (a^.pocet < rad) and (a^.ukazzp <> NIL) then begin
      b:= a^.ukazzp;
      i:= 0;
      while b^.ukaz[i] <> a do begin
        inc(CITAC);
        i:= i+1;
      end;
      puc:= i;                                          {puc je cislo ukazatele v otci na aktualni uzel}
      l:= NIL;
      p:= NIL;
      if i > 0 then        l:= b^.ukaz[i-1];
      if i < b^.pocet then p:= b^.ukaz[i+1];

      povedlo:= false;
      if (p <> NIL) and (p^.pocet > rad) then begin         {pujcka zprava}
        a^.data[a^.pocet]:= b^.data[puc];               {a je aktualni, b je otec,l levy bratr a, p pravy bratr a}
        a^.ukaz[a^.pocet + 1]:= p^.ukaz[0];
        p^.ukaz[0]^.ukazzp:= a;                         {ukazzp presunuteho potomka nastavime na aktualni uzel}
        b^.data[puc]:= p^.data[0];
        a^.pocet:= a^.pocet+1;
        p^.pocet:= p^.pocet-1;

        for i:=0 to p^.pocet-1 do begin
          inc(CITAC);
          p^.data[i]:= p^.data[i+1];
          p^.ukaz[i]:= p^.ukaz[i+1];
        end;
        p^.ukaz[i+1]:= p^.ukaz[i+2];

        for i:= p^.pocet to 2*rad do begin
          p^.ukaz[i+1]:= NIL;
          p^.data[i]:= 0;
        end;

        povedlo:= true;
      end;

      if (not povedlo) and (l <> NIL) and (l^.pocet > rad) then begin    {pujcka zleva}
        a^.pocet:= a^.pocet+1;
        for i:= 0 to a^.pocet-1 do begin
          inc(CITAC);
          a^.data[i+1]:= a^.data[i];
          a^.ukaz[i+1]:= a^.ukaz[i];
        end;
        a^.ukaz[i+2]:= a^.ukaz[i+1];
        a^.data[0]:= b^.data[puc-1];

        b^.data[puc-1]:= l^.data[l^.pocet-1];
        a^.ukaz[0]:= l^.ukaz[l^.pocet];
        l^.ukaz[l^.pocet]^.ukazzp:= a;

        l^.pocet:= l^.pocet-1;
        for i:= l^.pocet to 2*rad do begin
          l^.ukaz[i+1]:= NIL;
          l^.data[i]:= 0;
        end;

        povedlo:= true;
      end;

      if not povedlo then begin                                        {slouceni}
        hotovo:= false;
        if p<>NIL then begin                                      {zprava}
          a^.data[a^.pocet]:= b^.data[puc];                       {kopirujeme prvek z predchudce do a}
          a^.pocet:= a^.pocet + 1;
          for i:= 0 to p^.pocet-1 do begin                        {kopirujeme prvky zprava do aktualniho}
            inc(CITAC);
            a^.data[i+a^.pocet]:= p^.data[i];
            a^.ukaz[i+a^.pocet]:= p^.ukaz[i];
          end;
          a^.pocet:= a^.pocet + p^.pocet;                               {zmeni se pocet}
          a^.ukaz[a^.pocet]:= p^.ukaz[p^.pocet];                        {kopne se tam posledni ukazatel}
          for i:= 0 to p^.pocet do begin
            inc(CITAC);
            p^.ukaz[i]^.ukazzp:= a;                                     {zmena predka potomku co se presunuli}
          end;
          b^.ukaz[puc+1]:= a;
          dispose(p);
          a:= b;
          c:= puc;

        end else begin                                            {zleva}
          l^.data[l^.pocet]:= b^.data[puc-1];
          l^.pocet:= l^.pocet + 1;
          for i:= 0 to a^.pocet - 1 do begin
            inc(CITAC);
            l^.data[i+l^.pocet]:= a^.data[i];
            l^.ukaz[i+l^.pocet]:= a^.ukaz[i];
          end;
          l^.pocet:= l^.pocet + a^.pocet;
          l^.ukaz[l^.pocet]:= a^.ukaz[a^.pocet];
          for i:= 0 to a^.pocet do begin
            inc(CITAC);
            a^.ukaz[i]^.ukazzp:= l;                                     {zmena predka potomku co se presunuli}
          end;
          dispose(a);
          a:= b;
          c:= puc-1;
        end;
      end;
    end;
    pujcsluc:= hotovo;
end;

procedure mazuzel(var a : puzel; var c : integer);
var b : puzel;
begin
  b:= a^.ukaz[c];                                       {do leveho podstromu}
  while (b^.ukaz[0] <> NIL) do begin                    {do nejpravejsiho listu}
    inc(CITAC);
    b:= b^.ukaz[b^.pocet];
  end;
  a^.data[c]:= b^.data[b^.pocet-1];                     {nahrazeni}
  a:= b;
  c:= b^.pocet-1;
end;


procedure mazlist(var a : puzel; var c : integer; var koren : puzel);
var hotovo : boolean;
begin
  hotovo:= false;
  while not hotovo do begin
    inc(CITAC);
    hotovo:= pujcsluc(a, c);
    if (a^.ukazzp = NIL) and (a^.pocet = 0) and (a^.ukaz[0] <> NIL) then begin
      dispose(koren);
      koren:= a^.ukaz[0];
      koren^.ukazzp:= NIL;
      hotovo:= true;
    end;
  end;
end;

function bstrom.uber(klic : integer) : boolean;
var a : puzel;
    i, c : integer;
    nalezen, skok, list : boolean;
begin
  a:= koren;
  nalezen:= false;

  while a^.ukaz[0] <> NIL do begin              {hledame prvek}
    inc(CITAC);
    skok:= false;
    for i:=0 to a^.pocet-1 do begin
      inc(CITAC);
      if klic <= a^.data[i] then begin
        skok:= true;
        break;
      end;
    end;
    if klic = a^.data[i] then begin
      nalezen:= true;
      break;
    end;
    if skok then a:= a^.ukaz[i]
    else a:= a^.ukaz[a^.pocet];
  end;

  if not nalezen then begin                     {prohledava se list}
    for i:= 0 to a^.pocet-1 do begin
      inc(CITAC);
      if klic = a^.data[i] then begin
        nalezen:= true;
        break;
      end;
    end;
  end;

  if nalezen then begin

  c:= i;

  if a^.ukaz[0] = NIL then list:= true          {rozhodne se kde je prvek}
  else list:= false;

  if not list then begin
    mazuzel(a, c);
    mazlist(a, c, koren);

  end;

  if list then mazlist(a, c, koren);

  uber:= true;
  end else uber:= false;

end;

function bstrom.najdi(klic : integer) : boolean;
var a : puzel;
    i, c : integer;
    nalezen, skok : boolean;
begin
  a:= koren;
  nalezen:= false;

  while a^.ukaz[0] <> NIL do begin              {hledame prvek}
    inc(CITAC);
    skok:= false;
    for i:=0 to a^.pocet-1 do begin
      inc(CITAC);
      if klic <= a^.data[i] then begin
        skok:= true;
        break;
      end;
    end;
    if klic = a^.data[i] then begin
      nalezen:= true;
      break;
    end;
    if skok then a:= a^.ukaz[i]
    else a:= a^.ukaz[a^.pocet];
  end;

  if not nalezen then begin                     {prohledava se list}
    for i:= 0 to a^.pocet-1 do begin
      inc(CITAC);
      if klic = a^.data[i] then begin
        nalezen:= true;
        break;
      end;
    end;
  end;

  najdi:= nalezen;
end;


function zadejrad : integer;
var r : integer;
begin
  clrscr;
  write('Zadej rad stromu: ');
  readln(r);
  if (r > MAXbs/2) or (r <= 0) then begin
    writeln('MIMO meze => rad bude 2');
    r:= 2;
  end;
  zadejrad:= r;
end;

function menu : integer;
var m : integer;
begin
  writeln;
  writeln('Vyber volbu: 1 - pridej :: 2 - uber :: 3 - hledaj :: 4 - vypis :: 0 - KONEC');
  write('VOLBA: ');
  readln(m);
  menu:= m;
end;

function zadej : integer;
var h : integer;
begin
  write('Zadej cislo (0 pro konec): ');
  readln(h);
  zadej:= h;
end;

var strom : bstrom;
    r, m, h : integer;

begin
  r:= zadejrad;
  strom.novy(r);

  m:= 1;
  while m<>0 do begin
    m:= menu;
    if m = 1 then begin
      h:= -1;
      while h <> 0 do begin
        h:= zadej;
        if h <> 0 then
          if not strom.pridej(h) then writeln('UZ to tam je.');
      end;
    end;
    if m = 2 then begin
      h:= -1;
      while h <> 0 do begin
        h:= zadej;
        if h <> 0 then
          if not strom.uber(h) then writeln('TO tam neni.');
      end;
    end;
    if m = 3 then begin
      write('Hledany prvek: ');
      readln(h);
      if strom.najdi(h) then write('JE to tam.')
      else write('NENI to tam.');
    end;
    if m = 4 then strom.vypis;
  end;

  writeln('.:DEKUJEME ODEJDETE:.');

end.